;.equ XSize=40 ;characters per line
;.equ YSize=25 ;lines per frame
.equ XStart=98
.equ YStart=52
.equ scanlinecount=312
.equ blacktop=YStart
.equ blackbottom=scanlinecount-YStart-YSize*8
.equ Syncwidth=80
.equ Linewidth=1024
.equ porchwidth=40
.equ vsyncwidth=432

.dseg
;ddram: .byte XSize*YSize

;tvt_state: .byte 1
;tvt_count: .byte 1
;tvt_cursorx: .byte 1
;tvt_cursory: .byte 1
;tvt_time_n4: .byte 1 ; 2^-32 seconds
;tvt_time_n3: .byte 1 ; 2^-24 seconds
;tvt_time_n2: .byte 1 ; 2^-16 seconds 
;tvt_time_n1: .byte 1 ; 2^-8 seconds
;tvt_time_0: .byte 1 ; 1 seconds     \ 
;tvt_time_1: .byte 1 ; 2^16 seconds   \ Unix time
;tvt_time_2: .byte 1 ; 2^24 seconds   /
;tvt_time_3: .byte 1 ; 2^32 seconds  /

.cseg
.def tvt_isr_temp = r16
.def tvt_isr_temp2= r17
.def tvt_isr_temp3= r18
.def tvt_isr_temp4= r19

OC1Aisr: ;running at xstart+?
    push tvt_isr_temp	;2
    in tvt_isr_temp,sreg;1
    push tvt_isr_temp	;2
    push tvt_isr_temp2	;2
    push tvt_isr_temp3	;2
    push tvt_isr_temp4	;2
    push xh		;2
    push xl		;2
    push zh		;2
    push zl		;2
; rjmp  OC1Aisr_backjump

    ;compensate for yitter; @xstart+?+19
    in zl, TCNT1L
    in zh, tcnt1h
    ;substract XStart
    subi zl, low(XStart+20)
    sbci zh,high(XStart+20)
    ;keep value within 0..15
    ANDI zl,$0f;
    ANDI zh,0
    
    subi zl, low(-OC1Aisr_comp) ;
    sbci zh,high(-OC1Aisr_comp) 
    ijmp 
 OC1Aisr_comp:
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    LDS tvt_isr_temp, tvt_state ;load state
    ;branch based on state
    
    CPI tvt_isr_temp,0
    BREQ tvt_blankline_top_
    
    CPI tvt_isr_temp,1
    BREQ tvt_scanline_
    
    CPI tvt_isr_temp,2
    BREQ tvt_blankline_bottom_
    
    CPI tvt_isr_temp,3
    BREQ tvt_hsync_pre_
    
    CPI tvt_isr_temp,4
    BREQ tvt_hsync_during_
    
    CPI tvt_isr_temp,5
    BREQ tvt_hsync_post_
    
    LDI tvt_isr_temp,0
    STS tvt_state,tvt_isr_temp 
 OC1Aisr_backjump: ;branches come back here
    pop zl
    pop zh
    pop xl
    pop xh
    pop tvt_isr_temp4
    pop tvt_isr_temp3
    pop tvt_isr_temp2
    pop tvt_isr_temp
    out sreg,tvt_isr_temp
    pop tvt_isr_temp
  reti    

;help-jumps
tvt_blankline_top_:
    jmp tvt_blankline_top
tvt_scanline_:
    jmp tvt_scanline
tvt_blankline_bottom_:
    jmp tvt_blankline_bottom
tvt_hsync_pre_:
    jmp tvt_hsync_pre
tvt_hsync_during_:
    jmp tvt_hsync_during
tvt_hsync_post_:
    jmp tvt_hsync_post

 
tvt_hsync_pre: ;tvt_state=3
LDI tvt_isr_temp, (1<<COM1B1)|(0<<COM1B0)|(1<<(1))|(1<<(0)) 
OUT TCCR1A,tvt_isr_temp
    
    LDI tvt_isr_temp,high(linewidth/2) 
    OUT ICR1H,tvt_isr_temp
    LDI tvt_isr_temp,low(linewidth/2) ;
    OUT ICR1L,tvt_isr_temp
    LDI tvt_isr_temp,high(porchwidth);
    OUT OCR1BH,tvt_isr_temp
    LDI tvt_isr_temp,low(porchwidth)
    OUT OCR1BL,tvt_isr_temp

    call tvt_count_time
    call tvt_count_time
    

    LDS tvt_isr_temp, tvt_count
    inc tvt_isr_temp
    CPI tvt_isr_temp, 5 ;5 frontporches
    BRGE tvt_hsync_pre_end 
    ;last line
    LDI tvt_isr_temp,4 ;go  to tvt_state=4 (tvt_hsync_during)
    STS tvt_state,tvt_isr_temp
    LDI tvt_isr_temp,0
  tvt_hsync_pre_end:    
    STS tvt_count,tvt_isr_temp
 jmp OC1Aisr_backjump
 
tvt_hsync_post: ;tvt_state=5
    LDI tvt_isr_temp,high(linewidth/2) 
    OUT ICR1H,tvt_isr_temp
    LDI tvt_isr_temp,low(linewidth/2) ;
    OUT ICR1L,tvt_isr_temp
    LDI tvt_isr_temp,high(porchwidth);
    OUT OCR1BH,tvt_isr_temp
    LDI tvt_isr_temp,low(porchwidth)
    OUT OCR1BL,tvt_isr_temp
    LDI tvt_isr_temp,high(XStart)
    OUT OCR1AH,tvt_isr_temp
    LDI tvt_isr_temp,low(XStart)    
    OUT OCR1AL,tvt_isr_temp
    
    CALL tvt_count_time
    CALL tvt_count_time

    LDS tvt_isr_temp, tvt_count
    inc tvt_isr_temp
    CPI tvt_isr_temp, 5 ;5 frontporches
    BRGE tvt_hsync_post_end 
    ;last line
    LDI tvt_isr_temp,0 ;go  to tvt_state=0 (blank top)
    STS tvt_state,tvt_isr_temp
    LDI tvt_isr_temp,0
  tvt_hsync_post_end:    
    STS tvt_count,tvt_isr_temp
 jmp OC1Aisr_backjump
 
tvt_hsync_during: ;tvt_state=4
    LDI tvt_isr_temp,high(linewidth/2) 
    OUT ICR1H,tvt_isr_temp
    LDI tvt_isr_temp,low(linewidth/2) ;
    OUT ICR1L,tvt_isr_temp
    LDI tvt_isr_temp,high(vsyncwidth);
    OUT OCR1BH,tvt_isr_temp
    LDI tvt_isr_temp,low(vsyncwidth)
    OUT OCR1BL,tvt_isr_temp
    
    CALL tvt_count_time
    CALL tvt_count_time
    
    LDS tvt_isr_temp, tvt_count
    inc tvt_isr_temp
    CPI tvt_isr_temp, 5 ;5 frontporches
    BRGE tvt_hsync_during_end 
    ;last line
    LDI tvt_isr_temp,5 ;go  to tvt_state=5 (hsync_post)
    STS tvt_state,tvt_isr_temp
    LDI tvt_isr_temp,0
  tvt_hsync_during_end:    
    STS tvt_count,tvt_isr_temp
 jmp OC1Aisr_backjump
 
tvt_scanline: ;called when tvt_state=1
    Push r0
    push r1
    LDS tvt_isr_temp,tvt_count
    MOV Zh,tvt_isr_temp
    LSR tvt_isr_temp
    LSR tvt_isr_temp
    LSR tvt_isr_temp
    LDI tvt_isr_temp2,XSize
    MUL tvt_isr_temp,tvt_isr_temp2
    LDI Xl,low(ddram)
    LDI Xh,high(ddram)
    ADD Xl,r0
    ADC Xh,r1 ;X start of line in ddram
    
    LDI tvt_isr_temp3,255 ;set cursorpattern
    LDS tvt_isr_temp2,tvt_cursory
    CPSE tvt_isr_temp,tvt_isr_temp2
    LDI tvt_isr_temp3,0 ;reset cursorpattern
    
    LDS tvt_isr_temp2,tvt_time_n1
    ANDI tvt_isr_temp2,$40
    LDI tvt_isr_temp,$40
    CPSE tvt_isr_temp,tvt_isr_temp2
    LDI tvt_isr_temp3,0
    
    MOV tvt_isr_temp,Zh
    LDI Zl,low(char_rom*2) ;should be 0
    LDI ZH,high(char_rom*2)
    ANDI tvt_isr_temp,$07
    ADD ZH,tvt_isr_temp
    
    ;Z points at start of current line in character rom
    LDI tvt_isr_temp2,XSize
    LDS tvt_isr_temp4,tvt_cursorx
    NEG tvt_isr_temp4
    SUBI tvt_isr_temp4,-40 ;give 40-cursorx for cursor
    SBI DDRB,6 ; turn on serial output
  tvt_line_loop: ;should have precisely 18 clock cycles
    LD Zl,X+		;2
    LPM tvt_isr_temp,Z  ;3
    nop
    nop
    nop
    nop
    nop
    nop
    EOR tvt_isr_temp,tvt_isr_temp3 ; XOR with cursor bitpattern
    cpse tvt_isr_temp2,tvt_isr_temp4 ;temp4 contains 40-cursorx
    EOR tvt_isr_temp,tvt_isr_temp3 ; XOR with cursor bitpattern
    OUT SPDR,tvt_isr_temp;1
    DEC tvt_isr_temp2 	;1
    BRNE tvt_line_loop ; ^2^; v1v
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    LDI tvt_isr_temp2,0
    OUT SPDR,tvt_isr_temp2
    CBI DDRB,6 ; turn off serial output
    
    CALL tvt_count_time
    
    
    ;check for end of area
    LDS tvt_isr_temp2, tvt_count
    inc tvt_isr_temp2
    CPI tvt_isr_temp2, YSize*8 
    BRNE tvt_scanline_end 
    ;last line of picture
    LDI tvt_isr_temp,2 ;go  to tvt_state=2 (blank area bottom)
    STS tvt_state,tvt_isr_temp
    LDI tvt_isr_temp2,0
    
  tvt_scanline_end:    
    STS tvt_count,tvt_isr_temp2
    pop r1
    pop r0    
 jmp OC1Aisr_backjump
 
tvt_blankline_bottom:;tvt_state=2
    CALL tvt_count_time
    
    LDS tvt_isr_temp, tvt_count
    inc tvt_isr_temp
    CPI tvt_isr_temp, blackbottom
    BRLT tvt_blankline_bottom_end 
    ;last line
    LDI tvt_isr_temp,3 ;go  to tvt_state=3 (hsync)
    STS tvt_state,tvt_isr_temp
    LDI tvt_isr_temp,0
  tvt_blankline_bottom_end:    
    STS tvt_count,tvt_isr_temp
 jmp OC1Aisr_backjump

tvt_blankline_top:;tvt_state=0
    ;set linewidth in timer
    LDI tvt_isr_temp, (1<<COM1B1)|(1<<COM1B0)|(1<<(1))|(1<<(0)) 
    OUT TCCR1A,tvt_isr_temp
    
    LDI tvt_isr_temp,high(linewidth) ;
    OUT ICR1H,tvt_isr_temp
    LDI tvt_isr_temp,low(linewidth) ;
    OUT ICR1L,tvt_isr_temp
    LDI tvt_isr_temp,high(syncwidth);
    OUT OCR1BH,tvt_isr_temp
    LDI tvt_isr_temp,low(syncwidth)
    OUT OCR1BL,tvt_isr_temp
    LDI tvt_isr_temp,high(XStart)
    OUT OCR1AH,tvt_isr_temp
    LDI tvt_isr_temp,low(XStart)    
    OUT OCR1AL,tvt_isr_temp
    
    CALL tvt_count_time
    
    LDS tvt_isr_temp, tvt_count
    inc tvt_isr_temp
    CPI tvt_isr_temp, blacktop
    BRLT tvt_blankline_top_end 
    ;last line
    LDI tvt_isr_temp,1 ;go  to tvt_state=1 (textline)
    STS tvt_state,tvt_isr_temp
    LDI tvt_isr_temp,0
  tvt_blankline_top_end:    
    STS tvt_count,tvt_isr_temp
 jmp OC1Aisr_backjump
 
tvt_count_time: ;to be called with 31250Hz
  ;add 137439*2 to time variable
    LDS tvt_isr_temp,tvt_time_n4
    LDI tvt_isr_temp2,189
    ADD tvt_isr_temp,tvt_isr_temp2
    STS tvt_time_n4,tvt_isr_temp
    
    LDS tvt_isr_temp,tvt_time_n3
    LDI tvt_isr_temp2,49
    ADC tvt_isr_temp,tvt_isr_temp2
    STS tvt_time_n3,tvt_isr_temp
    
    LDS tvt_isr_temp,tvt_time_n2
    LDI tvt_isr_temp2,4
    ADC tvt_isr_temp,tvt_isr_temp2
    STS tvt_time_n2,tvt_isr_temp
    
    LDI tvt_isr_temp2,0
    
    LDS tvt_isr_temp,tvt_time_n1
    ADC tvt_isr_temp,tvt_isr_temp2
    STS tvt_time_n1,tvt_isr_temp
    
    LDS tvt_isr_temp,tvt_time_0
    ADC tvt_isr_temp,tvt_isr_temp2    
    STS tvt_time_0,tvt_isr_temp
    
    LDS tvt_isr_temp,tvt_time_1
    ADC tvt_isr_temp,tvt_isr_temp2    
    STS tvt_time_1,tvt_isr_temp
    
    LDS tvt_isr_temp,tvt_time_2
    ADC tvt_isr_temp,tvt_isr_temp2
    STS tvt_time_2,tvt_isr_temp
    
    LDS tvt_isr_temp,tvt_time_3
    ADC tvt_isr_temp,tvt_isr_temp2
    STS tvt_time_3,tvt_isr_temp
ret 
  

.def tvt_temp1=r19
.def tvt_temp2=r20
.def tvt_temp3=r21
.def tvt_temp4=r22

tvt_init:
    push tvt_temp1
   ;reset all memory registers
    LDI tvt_temp1,0
    STS tvt_state,tvt_temp1
    STS tvt_count,tvt_temp1
    LDI tvt_temp1,4
    STS tvt_cursorx,tvt_temp1
    STS tvt_cursory,tvt_temp1
   ;init ports
    LDI tvt_temp1,255
    OUT DDRB,tvt_temp1
    ;port for sync missing!!!
   ;init SPI    
    LDI tvt_temp1, (1<<SPE)|(1<<MSTR)|(1<<CPHA)|(1<<DORD)
    OUT SPCR,tvt_temp1
    SBI SPSR,SPI2x
   ;init timer for Sync
    LDI tvt_temp1,high(linewidth) 
    OUT ICR1H,tvt_temp1
    LDI tvt_temp1,low(linewidth) 
    LDI tvt_temp1,high(syncwidth);
    OUT OCR1BH,tvt_temp1
    LDI tvt_temp1,low(syncwidth)
    OUT OCR1BL,tvt_temp1
    LDI tvt_temp1,high(XStart)
    OUT OCR1AH,tvt_temp1
    LDI tvt_temp1,low(XStart)    
    OUT OCR1AL,tvt_temp1
    LDI tvt_temp1, (1<<COM1B1)|(1<<COM1B0)|(1<<(1))|(1<<(0)) 
    OUT TCCR1A,tvt_temp1
    LDI tvt_temp1, (1 << 3) | 1
    OUT TCCR1B,tvt_temp1
    LDI tvt_temp1,(1<<OCIE1A)
    out timsk,tvt_temp1
    LDI tvt_temp1,(1<<OCF1A)
    out TIFR,tvt_temp1
   ;set ports to output
    SBI DDRB,4 ; turn on slave select
    SBI PORTB,4
    SBI DDRB,6 ; turn on serial output
    
    SBI DDRD,4 ;turn on sync output
;    SBI DDRD,6 ;turn on LED port
    
    sei
   call tvt_clear_screen
     pop tvt_temp1
    ret
    
 tvt_clear_screen:
    push tvt_temp1
    push tvt_temp2
    push tvt_temp3
    push tvt_temp4
    push Xl
    push xh
    LDI tvt_temp3,' '
    LDI Xl,low(ddram)
    LDI Xh,high(ddram)
    LDI tvt_temp1,XSize    
    LDI tvt_temp2,YSize
   tvt_clear_screen_loop1:
    LDI tvt_temp1,XSize
   tvt_clear_screen_loop2:    
    ST X+,tvt_temp3
    dec tvt_temp1
    BRNE tvt_clear_screen_loop2
    dec tvt_temp2
    BRNE tvt_clear_screen_loop1
    LDI tvt_temp1,0
    STS tvt_cursorx,tvt_temp1
    STS tvt_cursory,tvt_temp1
    pop xh
    pop xl
    pop tvt_temp4
    pop tvt_temp3
    pop tvt_temp2
    pop tvt_temp1
 ret
  
 
.macro calculate_cursor_pointer
    LDS tvt_temp1,tvt_cursory
    LDI tvt_temp2,XSize
    MUL tvt_temp1,tvt_temp2
    LDI Xl,low(ddram)
    LDI xh,high(ddram)
    ADD Xl,r0
    ADC Xh,r1 
    LDS tvt_temp1,tvt_cursorx
    LDI tvt_temp2,0
    ADD Xl,tvt_temp1
    ADD xh,tvt_temp2
.endmacro 

 
tvt_emit: ;emits character in tosl
    push tvt_temp1
    push tvt_temp2
    push Xl
    push Xh
    MOV tvt_temp1,tosl
    CPI tvt_temp1,10
    BREQ tvt_carriage_return
    CPI tvt_temp1,13
    BREQ tvt_new_line
    CPI tvt_temp1,8
    BREQ tvt_backspace
    
    
    calculate_cursor_pointer
    
    ST X,tosl
    
  ; move cursor
    
    LDS tvt_temp1,tvt_cursorx
    CPI tvt_temp1,XSize-1
    BRSH tvt_new_line
    inc tvt_temp1
    STS tvt_cursorx,tvt_temp1
    rjmp tvt_emit_done
    
  tvt_backspace:
    LDS tvt_temp1,tvt_cursorx
    CPI tvt_temp1,0   ;if in column 0
    BREQ tvt_emit_done ;do not do anything
    dec tvt_temp1
    STS tvt_cursorx,tvt_temp1     
    rjmp tvt_emit_done
  
  tvt_new_line:
    LDS tvt_temp1,tvt_cursory
    CPI tvt_temp1,Ysize-1
    BRSH tvt_emit_scroll
    inc tvt_temp1
    STS tvt_cursory,tvt_temp1
    rjmp tvt_carriage_return
  tvt_emit_scroll:
    call tvt_scroll
    LDI tvt_temp1,YSize-1
    STS tvt_cursory,tvt_temp1    
  tvt_carriage_return:
    LDI tvt_temp1,0
    STS tvt_cursorx,tvt_temp1      
  tvt_emit_done:    
    pop xh
    pop xl
    pop tvt_temp2
    pop tvt_temp1    
ret 
    
tvt_scroll: ;to be called from tvt_emit
    push yh
    push yl
    push tvt_temp3
    ;set pointers
    LDI Xl,low(ddram+XSize)
    LDI Xh,high(ddram+XSize)
    LDI Yl,low(ddram)
    LDI Yh,high(ddram)
    LDI tvt_temp2,YSize-1
    
   tvt_scroll_loop2:
    LDI tvt_temp1,XSize
    
   tvt_scroll_loop1:    
    LD tvt_temp3,X+
    ST Y+,tvt_temp3
    dec tvt_temp1
    BRNE tvt_scroll_loop1
    
    dec tvt_temp2
    BRNE tvt_scroll_loop2
    
   ;clear bottom most line
    LDI yl, low(ddram+XSize*(YSize-1))
    LDI yh,high(ddram+XSize*(YSize-1))
    LDI tvt_temp2,XSize
   tvt_scroll_loop3:
    LDI tvt_temp1,' '
    ST Y+,tvt_temp1
;    SUBI Yl,-1
;    SBCI Yh,0
    dec tvt_temp2
    BRNE tvt_scroll_loop3        
    pop tvt_temp3
    pop yl
    pop yh
ret