;;; keyboard driver

;; bit definitions

.set pc_ = pc
.org URXCaddr
  jmp keyboard_key_irq_handler
.org pc_

.dseg
;.set pc_ = pc
.org heap
keyboard_shift: .byte 1
keyboard_buffer: .byte 1
.set heap = heap + 2
;.org pc_
.cseg

; ( -- c)  Hardware Access
; R( --)
; get 1 character from input queue, wait if needed
VE_RX_tv:
    .db $05, "rx_tv"
    .dw VE_HEAD
    .set VE_HEAD = VE_RX_tv
XT_RX_tv:
    .dw DO_COLON
PFA_RX_tv:
  .dw XT_RX_tvQ
  .dw XT_DOCONDBRANCH
  .dw PFA_RX_tv
  .dw XT_DOLITERAL
  .dw keyboard_buffer
  .dw XT_CFETCH
  .dw XT_ZERO
  .dw XT_DOLITERAL
  .dw keyboard_buffer
  .dw XT_CSTORE
  .dw XT_EXIT

; ( -- f)  Hardware Access
; R( --)
; check if unread characters are in the input queue.
VE_RX_tvQ:
    .db $06, "rx_tv?",0
    .dw VE_HEAD
    .set VE_HEAD = VE_RX_tvQ
XT_RX_tvQ:
    .dw DO_COLON
PFA_RX_tvQ:
  .dw XT_PAUSE
  .dw XT_DOLITERAL
  .dw keyboard_buffer
  .dw XT_CFETCH
  .dw XT_DOLITERAL
  .dw 0
  .dw XT_NOTEQUAL
  .dw XT_EXIT


; ( -- )  Hardware Access
; R( --)
; init_keyboard
VE_RX_tv_init:
    .db 10, "rx_tv_init",0
    .dw VE_HEAD
    .set VE_HEAD = VE_RX_tv_init
XT_RX_tv_init:
    .dw PFA_RX_tv_init
PFA_RX_tv_init:
    call keyboard_init
    jmp DO_NEXT
