;;; usart driver

;; bit definitions

.set pc_ = pc
.org OC1Aaddr
  jmp_ OC1Aisr
.org pc_

.dseg

.org heap
ddram: .byte XSize*Ysize
tvt_state: .byte 1
tvt_count: .byte 1
tvt_cursorx: .byte 1
tvt_cursory: .byte 1
tvt_time_n4: .byte 1
tvt_time_n3: .byte 1
tvt_time_n2: .byte 1
tvt_time_n1: .byte 1
tvt_time_0: .byte 1
tvt_time_1: .byte 1
tvt_time_2: .byte 1
tvt_time_3: .byte 1

.set heap = heap + XSize*YSize+12
.cseg

; (c -- ) Hardware Access
; R( --)
; dummy thiny
VE_tv_clear:
    .db 8, "tv_clear",0
    .dw VE_HEAD
    .set VE_HEAD = VE_tv_clear
XT_tv_clear:
    .dw PFA_tv_clear
PFA_tv_clear:
    call tvt_clear_screen
    jmp DO_NEXT
    
VE_tv_emit:
    .db 7, "tv_emit"
    .dw VE_HEAD
    .set VE_HEAD = VE_tv_emit
XT_tv_emit:
    .dw PFA_tv_emit
PFA_tv_emit:
    call tvt_emit
    ld tosl,Y+
    ld tosh,Y+
    jmp DO_NEXT

VE_tv_emitq:
    .db 8, "tv_emit?",0
    .dw VE_HEAD
    .set VE_HEAD = VE_tv_emitq
XT_tv_emitq:
    .dw PFA_dovariable
PFA_tv_emitq:
    .dw $ffff

VE_tv_init:
    .db 7, "tv_init"
    .dw VE_HEAD
    .set VE_HEAD = VE_tv_init
XT_tv_init:
    .dw PFA_tv_init
PFA_tv_init:
    call tvt_init
    jmp DO_NEXT
